﻿

Public Class CTab : Inherits Panel
    Private bitmap As Bitmap
    Public _backColor As Color
    Private _foreColor As Color
    Private _font As Font
    Private _drawBrush As SolidBrush
    Private _drawBrushHover As SolidBrush
    Private _pen As Pen
    Private _penHover As Pen
    Private bSelected As Boolean = False
    Private scaption As String
    Dim g As Graphics

    Public Sub setProperties(caption As String, bkColor As Color, frColor As Color, font As Font, w As Integer, h As Integer)
        _backColor = bkColor
        _foreColor = frColor
        _font = font
        _drawBrush = New SolidBrush(_foreColor)
        _pen = New Pen(_backColor)
        _drawBrushHover = New SolidBrush(_backColor)
        _penHover = New Pen(_foreColor)
        Width = w
        Height = h
        scaption = caption
        bitmap = New Bitmap(Width, Height)
        g = Graphics.FromImage(bitmap)
    End Sub

    Protected Overrides Sub OnPaint(e As PaintEventArgs)
        draw(_pen, _penHover, _drawBrushHover)
    End Sub
    Protected Overrides Sub OnMouseHover(e As EventArgs)
        draw(_penHover, _pen, _drawBrush)
    End Sub

    Private Sub draw(_p As Pen, _pH As Pen, _d As SolidBrush)
        g.Clear(Color.Transparent)
        g.DrawLine(_p, 0, 0, Width - 11, 0)
        g.DrawLine(_p, Width - 11, 0, Width, 11)
        g.DrawLine(_p, Width, 0, Width, 80)
        g.DrawLine(_p, 0, 0, 1, 80)
        Dim i As Integer = 0
        For i = 1 To 10
            g.DrawLine(_pH, 1, i + 1, Width - (12 - i), i + 1)
        Next
        For i = 11 To 50
            g.DrawLine(_pH, 1, i + 1, Width - 2, i + 1)
        Next
        If (Not bSelected) Then
            Dim pg As New Pen(Color.Black)
            g.DrawLine(pg, 1, 33, Width - 3, 33)
        End If
        g.DrawString(scaption, _font, _d, New Point(5, Height / 5))
        Me.CreateGraphics.DrawImage(bitmap, New Point(1, 1))
    End Sub
    Protected Overrides Sub OnMouseLeave(e As EventArgs)
        If (Not bSelected) Then
            draw(_pen, _penHover, _drawBrushHover)
        Else
            draw(_penHover, _pen, _drawBrush)
        End If
    End Sub
    Public Sub SetSelected(selected As Boolean)
        bSelected = selected
    End Sub

    Public Sub updateTab(bkColor As Color, frColor As Color, fnt As Font)
        _backColor = bkColor
        _foreColor = frColor
        _font = fnt
        _drawBrush = Nothing
        _pen = Nothing
        _drawBrushHover = Nothing
        _penHover = Nothing
        _drawBrush = New SolidBrush(_foreColor)
        _pen = New Pen(_backColor)
        _drawBrushHover = New SolidBrush(_backColor)
        _penHover = New Pen(_foreColor)
        draw(_pen, _penHover, _drawBrushHover)
    End Sub
End Class
