﻿''''''''''''''''''''''''''''''''''
' Author - Nasri 2022 dzosoft.com
'''''''''''''''''''''''''''''''''''

Public Class Library
    Private pParent As Panel
    Private pPicture As PictureBox
    Private pPictDrag As PictureBox
    Private nCount As Integer
    Private bDown As Boolean
    Private source As Principal
    Private HscrollX As Integer = 0
    Private VscrollY As Integer = 0
    Private endDrag As Boolean

    Public Sub Load(_source As Principal, panMenu As Panel, imageDirectory As String)
        Const p As Integer = 10
        panMenu.BackColor = Color.White
        panMenu.AutoScroll = True
        source = _source
        source.AllowDrop = True
        AddHandler source.DragEnter, AddressOf DragEnter
        AddHandler source.DragDrop, AddressOf DragDrop

        Dim i, j As Integer
        i = 0
        j = 0
        For Each imageFile As String In My.Computer.FileSystem.GetFiles(imageDirectory)
            On Error Resume Next
            pPicture = New PictureBox()
            pPicture.Height = 80
            pPicture.Width = 80
            pPicture.Image = System.Drawing.Image.FromFile(imageFile)
            pPicture.SizeMode = PictureBoxSizeMode.StretchImage
            pPicture.Top = p + j * (pPicture.Height + 10)
            pPicture.Left = 10 + i * (pPicture.Width + 10)
            pPicture.AllowDrop = True
            AddHandler pPicture.MouseDown, AddressOf MouseDown
            AddHandler pPicture.MouseMove, AddressOf MouseMove

            If (i < 1) Then
                i += 1
            Else
                i = 0
                j += 1
            End If
            pPicture.Visible = True
            panMenu.Controls.Add(pPicture)
        Next

    End Sub
    Private Sub MouseDown(sender As Object, e As MouseEventArgs)
        On Error Resume Next
        HscrollX = source.DrawPan.HorizontalScroll.Value
        VscrollY = source.DrawPan.VerticalScroll.Value
        pPicture = DirectCast(sender, PictureBox)
        bDown = True
        endDrag = False
    End Sub
    Private Sub MouseMove(sender As Object, e As MouseEventArgs)
        If (bDown) Then
            pPicture.DoDragDrop(pPicture.Image, DragDropEffects.Copy)
        End If
        bDown = False
    End Sub

    Private Sub DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs)
        If (e.Data.GetDataPresent(DataFormats.Bitmap) AndAlso
          (e.AllowedEffect And DragDropEffects.Copy) <> 0) Then
            e.Effect = DragDropEffects.Copy
        Else
            e.Effect = DragDropEffects.None
        End If
    End Sub

    Private Sub DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs)
        Dim obj As New ptObject
        Dim bm As Bitmap = DirectCast(e.Data.GetData(DataFormats.Bitmap, True), Bitmap)
        If Not endDrag Then
            pPictDrag = New PictureBox
            pPictDrag.Image = bm
            pPictDrag.Left = e.X + HscrollX
            pPictDrag.Top = (e.Y + VscrollY) - bm.Height
            pPictDrag.Width = bm.Width
            pPictDrag.Height = bm.Height
            source.DrawPan.Controls.Add(pPictDrag)
            pPictDrag.BringToFront()
            obj.name = "img" & source.objDzoDraw.getObjCount()
            obj.X1 = New Point(pPictDrag.Left, pPictDrag.Top)
            obj.bitmap = New Bitmap(pPictDrag.Image)
            obj.X2 = New Point(obj.X1.X + bm.Width, pPictDrag.Top + bm.Height)
            obj.draw = Principal.IIMAGE
            obj.brightness = 1.2F
            obj.contrast = 1.0F
            obj.gamma = 1.0F
            source.objDzoDraw.lstDrawOject.Add(obj)
            source.DrawPan.Controls.Remove(pPictDrag)
            pPictDrag = Nothing
            source.DrawPan.Invalidate()
            endDrag = True
        End If
    End Sub
End Class