﻿''''''''''''''''''''''''''''''''''
' Author - Nasri 2022 dzosoft.com
'''''''''''''''''''''''''''''''''''

Public Class SliderDesigner

    Private minValue As Single
    Private maxValue As Single
    Private g As Graphics
    Private bm As Bitmap
    Private pPanel As New Panel
    Private bMouseDown As Boolean = False
    Private stepSlider As Integer
    Private brushFill As SolidBrush
    Private objDzoDraw As DZODraw
    Private ptObj As ptObject
    Private clrCursor As Color
    Private clrBkColor As Color
    Private icon As String

    Public Sub New(_icon As String, ByRef _ptObj As ptObject, width As Integer, height As Integer, _clrCursor As Color, _clrBkColor As Color)
        bm = New Bitmap(width, height)
        g = Graphics.FromImage(bm)
        ptObj = _ptObj
        clrCursor = _clrCursor
        clrBkColor = _clrBkColor
        brushFill = New SolidBrush(clrCursor)
        icon = _icon
    End Sub

    Public Function CreateSlide(_designer As DZODraw, x As Single, y As Single,
                               _minValue As Single,
                               _maxValue As Single) As Panel
        pPanel.Location = New Point(x, y)
        pPanel.Width = bm.Width
        pPanel.Height = bm.Height
        minValue = _minValue
        maxValue = _maxValue
        Select Case icon
            Case PPropertyGrid.iconBrightness
                stepSlider = ptObj.brightness * 100 + 6
            Case PPropertyGrid.iconContrast
                stepSlider = ptObj.brightness * 100 + 6
            Case PPropertyGrid.iconGamma
                stepSlider = ptObj.brightness * 100 + 6
            Case PPropertyGrid.iconPenSize
                stepSlider = ptObj.penSize + 6
            Case PPropertyGrid.iconCharSize
                stepSlider = ptObj.font.Size + 6
            Case PPropertyGrid.iconDCube
                stepSlider = ptObj.dCube + 6

        End Select
        AddHandler pPanel.Paint, AddressOf Paint
        AddHandler pPanel.MouseMove, AddressOf MouseMove
        AddHandler pPanel.MouseDown, AddressOf MouseDown
        AddHandler pPanel.MouseUp, AddressOf MouseUp
        pPanel.Visible = True
        pPanel.BringToFront()
        objDzoDraw = _designer
        draw()
        Return pPanel
    End Function

    Private Sub MouseMove(sender As Object, e As MouseEventArgs)
        If objDzoDraw Is Nothing Then Exit Sub
        If (e.Y < bm.Height / 2 - 20 And e.Y > bm.Height / 2 + 10) And
            (e.X < stepSlider + 6 And e.X > stepSlider + 9) Then
            Exit Sub
        End If
        g.Clear(Color.Transparent)
        If (e.Button = MouseButtons.Left And bMouseDown And e.X > 6 And e.X < pPanel.Width - 41) Then
            stepSlider = e.X - 6
            Dim value As Integer
            If pPanel.Top < 242 Then
                value = (stepSlider - 6) / 100
                ptObj.brightness = value
            Else
                If pPanel.Top < 282 Then
                    value = (stepSlider - 6) / 100
                    ptObj.contrast = value
                ElseIf pPanel.Top < 320 Then
                    value = (stepSlider - 6) / 100
                    ptObj.gamma = value
                Else
                    Select Case icon
                        Case PPropertyGrid.iconPenSize
                            ptObj.penSize = stepSlider - 6
                        Case PPropertyGrid.iconCharSize
                            If (stepSlider > 6) Then
                                ptObj.font = New Font(ptObj.font.Name, (stepSlider - 6))
                            End If
                        Case PPropertyGrid.iconDCube
                            value = (stepSlider - 6)
                            If (stepSlider > 6) Then
                                ptObj.dCube = value
                            End If
                    End Select
                End If

            End If

            draw()
            For Each pt In objDzoDraw.lstDrawOject
                If (pt.name = ptObj.name) Then
                    objDzoDraw.lstDrawOject.Remove(pt)
                    Exit For
                End If
            Next
            objDzoDraw.lstDrawOject.Add(ptObj)
            objDzoDraw.lstSelDrawOject.Clear()
            objDzoDraw.lstSelDrawOject.Add(ptObj)
            objDzoDraw.Draw()
        End If

    End Sub

    Public Function getValue() As Single
        Select Case icon
            Case PPropertyGrid.iconBrightness
                Return (stepSlider - 6) / 100
            Case PPropertyGrid.iconContrast
                Return (stepSlider - 6) / 100
            Case PPropertyGrid.iconGamma
                Return (stepSlider - 6) / 100
            Case PPropertyGrid.iconPenSize
                Return (stepSlider - 6)
            Case PPropertyGrid.iconCharSize
                Return (stepSlider - 6)
            Case PPropertyGrid.iconDCube
                Return (stepSlider - 6)
        End Select
    End Function
    Private Sub MouseDown(sender As Object, e As MouseEventArgs)
        bMouseDown = False
        If (e.Y < bm.Height / 2 - 20 And e.Y > bm.Height / 2 + 10) Then
            Exit Sub
        End If
        If (e.X < stepSlider + 6 And e.X > stepSlider + 9) Then
            Exit Sub
        End If
        bMouseDown = True
    End Sub

    Private Sub MouseUp(sender As Object, e As MouseEventArgs)
        bMouseDown = False
    End Sub


    Private Sub Paint(sender As System.Object, e As System.Windows.Forms.PaintEventArgs)
        draw()

    End Sub

    Private Sub draw()
        Dim szLines() As String
        Dim arrPixel(5) As String
        Dim i As Integer
        Dim x As Integer = bm.Width - 32
        Dim y As Integer = bm.Height / 2 - 16
        g.Clear(clrBkColor)
        szLines = icon.Split(";")
        For i = 0 To szLines.Length() - 2
            arrPixel = szLines(i).Split(",")
            bm.SetPixel(CInt(arrPixel(0) + x), CInt(arrPixel(1) + y), Color.FromArgb(CInt(arrPixel(2)), CInt(arrPixel(3)), CInt(arrPixel(4))))
        Next
        szLines = icon.Split(";")
        g.DrawLine(New Pen(clrCursor), 5, CInt(bm.Height / 2), CInt(bm.Width - 42), CInt(bm.Height / 2))
        g.FillRectangle(brushFill, New Rectangle(stepSlider + 6, bm.Height / 2 - 8, 8, bm.Height / 2 - 2))
        pPanel.CreateGraphics().DrawImage(bm, New Point(0, 0))
    End Sub

End Class
