﻿''''''''''''''''''''''''''''''''''
' Author - Nasri 2022
'''''''''''''''''''''''''''''''''''
Imports System.ComponentModel
Imports System.Xml
Imports System.Xml.Serialization
Imports System.IO
Imports System.Drawing.Drawing2D
Imports System.Drawing


Public Class Principal
    Private logo As Logo
    Private btnMenu(5) As Button
    Private panMenu(5) As Panel
    Private propertyMenu(3) As PPropertyGrid
    Private propertyGridButtonSave(3) As Panel
    Private propertyGridButtonCancel(3) As Panel
    Private toolTipText As New Label
    Private menuSel As Integer = 0
    Private fileNotFound As Boolean
    Const PLEFT As Integer = 40
    Public Shared HEIGHT_PROP As Integer
    Public Shared WIDTH_PROP As Integer = 250
    Public Shared xmlAppSetting As String = "AppSetting.xml"
    Public Shared xmlDesignSetting As String = "DesignSetting.xml"
    Private bActivated As Boolean = False
    Public arrCaption(2) As String
    Public arrpCaption(2) As String
    Public _appSettings As New AppSettings()
    Public _designSettings As New DesignSettings()
    Public _objSettings As New ObjSetting()
    Public objSetting As Settings
    Const HEIGHT_BUTTON = 30
    Public strMenu As String = "Option Menu|Option draw| Grafics | Icons | Help |Support "
    Public caption As String = "Clear|Line| Line with arrow | Line double arrow |Pen | Rectangle| Cube | Eclipse|curves| bolt |Fill|Select|Copy|Paste|Cancel|Image|Text|Grid|Zoom - |Zoom +| Exit"
    Public strTabs As String = "Draw|Print|Tab 1|Tab 2| Tab 3"
    Public tabsPanel(5) As Panel
    Public tabsButton(5) As CTab
    Public arrButton(21) As CDButton
    Public dmenu As Menu
    Dim btn As CDButton
    Public imageBitmap As Bitmap
    Public nMode As Integer
    Public bCopy As Boolean
    Public bPaste As Boolean
    Public Const CLEAR = 0
    Public Const LINE = 1
    Public Const LINEARROW = 2
    Public Const LINEARROWSE = 3
    Public Const PEN = 4
    Public Const RECTANGLE = 5
    Public Const CUBE = 6
    Public Const ELLIPSE = 7
    Public Const CURVE = 8
    Public Const BOLT = 9
    Public Const FILL = 10
    Public Const SELECTION = 11
    Public Const COPY = 12
    Public Const PASTE = 13
    Public Const DELETE = 14
    Public Const IIMAGE = 15
    Public Const LABEL = 16
    Public Const GRID = 17
    Public Const ZOOM_M = 18
    Public Const ZOOM_P = 19
    Public Const EXIT_APP = 20
    Public Const OK = 21
    Public Const CANCEL = 22
    Public Const NONE = -1
    Public objDzoDraw As DZODraw
    Public libraryImage As Library
    Public hhelp As Help
    Private libraryLed As Panel
    Private librarySwitch As Panel
    Private libraryIcons As Library
    Private panelToolBarDesign As Panel
    Private bkColorSel As Color = Color.Red
    Private foreColorSel As Color = Color.Black
    Private cursorFill As New Cursor("bucket.cur")
    Public bGrid As Boolean = False
    Public stmPdf As pdfDraw.PrintPdf
    Public HscrollX As Integer
    Public VscrollV As Integer
    Public Const SOLID_STYLE = "______________________"
    Public Const DASH_STYLE = "----------------------"
    Public Const DOT_STYLE = "......................"
    Public Const DASDOT_STYLE = "-.-.-.-.-.-.-.-.-.-.-."
    Public nResizeLeft As Boolean = False
    Public nResizeRight As Boolean = False
    Public nResizeUp As Boolean = False
    Public nResizeDown As Boolean = False
    Public colorResizeCursor As Color = Color.Black
    Public colorMenuCursor As Color = Color.Black

    Private Sub Principal_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Dim i As Integer
        _appSettings = New AppSettings
        _appSettings.Load()
        _designSettings = New DesignSettings
        _designSettings.Load()
        objDzoDraw = New DZODraw(Me)
        objSetting = New Settings(_appSettings, xmlAppSetting, _designSettings, xmlDesignSetting)
        PropertiesPan.BackColor = ToolBar.BackColor
        arrCaption = strTabs.Split("|")
        For i = 0 To arrCaption.Length - 1
            ' Buttons
            tabsButton(i) = New CTab()
            tabsButton(i).setProperties(arrCaption(i), _designSettings.DesignBackColor,
            _appSettings.MenuForeColor, _appSettings.ApplicationFont, Len(arrCaption(i)) * 10, 80)
            tabsButton(i).Name = "Tab" & CStr(i)
            tabsButton(i).Left = Me.ToolBarPan.Left
            If (i > 0) Then
                tabsButton(i).Left = tabsButton(i - 1).Left + tabsButton(i - 1).Width - 2
            End If
            tabsButton(i).Top = Me.ToolBarPan.Bottom - tabsButton(i).Height
            tabsButton(i).Dock = DockStyle.None
            tabsButton(i).Visible = True
            tabsButton(i).Cursor = Cursors.Hand
            tabsButton(i).BringToFront()
            AddHandler tabsButton(i).Click, AddressOf tabsButton_click
            Me.ToolBarPan.Controls.Add(tabsButton(i))
            If (i > 0) Then
                tabsPanel(i) = New Panel
                tabsPanel(i).Left = DrawPan.Left
                tabsPanel(i).Top = DrawPan.Top
                tabsPanel(i).Width = DrawPan.Width
                tabsPanel(i).Height = DrawPan.Height
                tabsPanel(i).Dock = DrawPan.Dock
                tabsButton(i).SetSelected(False)
                tabsPanel(i).BackColor = Color.FromArgb(224 + i, 224 + i, 224 + i)
                tabsButton(i).updateTab(tabsPanel(i).BackColor, _appSettings.MenuBackColor, _appSettings.ApplicationFont)
                tabsPanel(i).Visible = False
                If i = 1 Then
                    stmPdf = New pdfDraw.PrintPdf(tabsPanel(i))
                    stmPdf.CreatePDFControls()
                End If
                Me.Controls.Add(tabsPanel(i))
            End If
        Next
        tabsButton(0).SetSelected(True)
        panelToolBarDesign = New Panel
        panelToolBarDesign.Left = ToolBarPan.Left
        panelToolBarDesign.Width = ToolBarPan.Width
        panelToolBarDesign.Height = 50
        arrpCaption = strMenu.Split("|")
        Dim p As Integer = 0
        For i = 0 To btnMenu.Length() - 1
            btnMenu(i) = New Button
            btnMenu(i).Text = arrpCaption(i)
            btnMenu(i).Width = PropertiesPan.Width - 80
            btnMenu(i).Left = 25
            btnMenu(i).Height = 30
            btnMenu(i).Top = 10 + i * (btnMenu(i).Height) + p
            p = p + 10
            btnMenu(i).BackColor = _appSettings.MenuBackColor
            btnMenu(i).ForeColor = _appSettings.MenuForeColor
            btnMenu(i).FlatStyle = FlatStyle.Flat
            btnMenu(i).Cursor = Cursors.Hand
            btnMenu(i).Visible = True
            Me.PropertiesPan.Controls.Add(btnMenu(i))
            AddHandler btnMenu(i).Click, AddressOf btnMenu_click
            AddHandler btnMenu(i).MouseHover, AddressOf HandleDynamicButtonMouseHover
            AddHandler btnMenu(i).MouseLeave, AddressOf HandleDynamicButtonMouseLeave
            panMenu(i) = New Panel
            panMenu(i).Width = btnMenu(i).Width
            panMenu(i).Top = btnMenu(i).Bottom + 2
            panMenu(i).Left = btnMenu(i).Left
            panMenu(i).Height = 600
            panMenu(i).Visible = False
            panMenu(i).BackColor = Color.White
            panMenu(i).TabIndex = i
            If (i = 0) Then
                propertyMenu(i) = New PPropertyGrid(objDzoDraw, panMenu(i), _appSettings, xmlAppSetting)
                propertyMenu(i).Create(PropertiesPan)
            End If
            If (i = 1) Then
                propertyMenu(i) = New PPropertyGrid(objDzoDraw, panMenu(i), _designSettings, xmlDesignSetting)
                propertyMenu(i).Create(PropertiesPan)
            End If
            If (i > 1) Then
                PropertiesPan.Controls.Add(panMenu(i))
            End If
            btnMenu(i).Invalidate()
        Next
        PropertiesPan.Invalidate()
        arrCaption = caption.Split("|")
        For i = 0 To arrCaption.Length - 1
            ' Buttons
            arrButton(i) = New CDButton With {
                .Top = 10,
                .Name = "BT" & CStr(i),
                .Text = arrCaption(i),
                .TabIndex = i,
                .Width = Me.Width / (arrButton.Length + 3),
                .Height = HEIGHT_BUTTON,
                .Font = New Font(_appSettings.ApplicationFont.Name, _appSettings.ApplicationFont.Size)
            }
            arrButton(i).setProperties(arrCaption(i), _appSettings.MenuBackColor, _appSettings.MenuForeColor, 32, 32)
            arrButton(i).Invalidate()

            If (i = 0) Then
                arrButton(i).Left = 10
            Else
                arrButton(i).Left = arrButton(i - 1).Left + arrButton(i - 1).Width + 10
            End If
            AddHandler arrButton(i).Click, AddressOf HandleDynamicButtonClick

            panelToolBarDesign.Controls.Add(arrButton(i))
        Next
        Me.ToolBarPan.Controls.Add(panelToolBarDesign)

        DrawPan.AutoScroll = True
        DrawPan.AutoScrollMinSize = New System.Drawing.Size(DrawPan.Size.Width * 2, DrawPan.Size.Height * 2)
        dmenu = New Menu(_appSettings.MenuBackColor, _appSettings.MenuForeColor, objDzoDraw)
        dmenu.CreateMenu(MenuPan, 0, 0)
        ToolBar.Height = HEIGHT_BUTTON * 5
        ReOrder()
        draw()
        bActivated = True
        WindowState = FormWindowState.Maximized
        libraryImage = New Library()
        libraryImage.Load(Me, panMenu(2), FileSystem.CurDir & "\graphics")
        libraryIcons = New Library()
        libraryImage.Load(Me, panMenu(3), FileSystem.CurDir & "\icons")
        UpdateColors()

        hhelp = New Help
        hhelp.Load(Me, panMenu(4))

        logo = New Logo
        logo.Left = 0
        logo.Dock = DockStyle.Right
        logo.Top = 20
        logo.Width = 37
        logo.Height = 124
        logo.Visible = True
        logo.BackColor = _appSettings.ApplicationBackColor
        logo.Invalidate()
        PropertiesPan.Controls.Add(logo)

    End Sub

    Private Sub ReOrder()
        If bActivated Then
            For i = 0 To arrCaption.Length - 1
                ' Buttons
                arrButton(i).Top = 50
                arrButton(i).Width = Me.Width / (arrButton.Length + 3)
                arrButton(i).Height = HEIGHT_BUTTON
                arrButton(i).Left = IIf(i = 0, 10, arrButton(i - 1).Left + arrButton(i - 1).Width + 10)
            Next
            ToolBar.Height = HEIGHT_BUTTON * 5
        End If
    End Sub

    Private Sub btnMenu_click(sender As Object, e As EventArgs)
        Dim btn As Button = DirectCast(sender, Button)
        For Each ctrl In Me.PropertiesPan.Controls
            If (ctrl.name <> "tooltip") Then
                ctrl.foreColor = _appSettings.MenuForeColor
            End If
            If (TypeOf ctrl Is Button And btn.Text = ctrl.Text) Then
                Dim p As Integer = 0
                For i = 0 To btnMenu.Length - 1
                    btnMenu(i).Height = 30
                    btnMenu(i).Top = 10 + i * (btnMenu(i).Height) + p
                    p = p + 10
                    If (btnMenu(i).Text = btn.Text) Then
                        menuSel = i
                    End If
                Next
                If (panMenu(menuSel).Visible) Then
                    panMenu(menuSel).Visible = False
                    Exit Sub
                End If
                For i = 0 To btnMenu.Length - 1
                    panMenu(i).Visible = False
                Next
                panMenu(menuSel).Visible = True
                panMenu(menuSel).Top = btn.Bottom + 2
                For i = menuSel + 1 To btnMenu.Length - 1
                    If (i = menuSel + 1) Then
                        btnMenu(i).Top = panMenu(menuSel).Bottom + 1
                    Else
                        btnMenu(i).Top = btnMenu(i - 1).Bottom + 10
                    End If
                Next
            End If
        Next

    End Sub

    Public Function IsInResize() As Boolean
        Return (nResizeLeft Or nResizeRight Or nResizeDown Or nResizeUp)
    End Function

    Public Sub ResetResize()
        Cursor = Cursors.Default
        nResizeLeft = False
        nResizeRight = False
        nResizeDown = False
        nResizeUp = False
    End Sub

    Private Sub HandleDynamicButtonMouseHover(sender As Object, e As EventArgs)
        Dim btn As Button = DirectCast(sender, Button)
        If btn.ForeColor = foreColorSel And btn.BackColor = bkColorSel Then Exit Sub
        btn.BackColor = _appSettings.MenuForeColor
        btn.ForeColor = _appSettings.MenuBackColor
    End Sub
    Private Sub HandleDynamicButtonMouseLeave(sender As Object, e As EventArgs)
        Dim btn As Button = DirectCast(sender, Button)
        If btn.ForeColor = foreColorSel And btn.BackColor = bkColorSel Then Exit Sub
        btn.BackColor = _appSettings.MenuBackColor
        btn.ForeColor = _appSettings.MenuForeColor
    End Sub


    Private Sub tabsButton_click(sender As Object, e As EventArgs)
        Dim i As Integer
        Dim btn As CTab = DirectCast(sender, CTab)
        DrawPan.Visible = False
        tabsButton(0).SetSelected(False)
        For i = 1 To tabsPanel.Length - 2
            tabsPanel(i).Visible = False
            tabsButton(i).SetSelected(False)
            tabsButton(i).updateTab(DrawPan.BackColor, _appSettings.MenuBackColor, _appSettings.ApplicationFont)
        Next
        btn.SetSelected(True)
        panelToolBarDesign.Visible = False
        If (CInt(Mid(btn.Name, 4)) = 0) Then
            DrawPan.Visible = True
            panelToolBarDesign.Visible = True
            tabsButton(btn.TabIndex).updateTab(DrawPan.BackColor, _appSettings.MenuBackColor,
                           _appSettings.ApplicationFont)
            DrawPan.BringToFront()
        Else
            tabsPanel(btn.TabIndex).Visible = True
            tabsButton(btn.TabIndex).updateTab(DrawPan.BackColor, _appSettings.MenuBackColor,
                                       _appSettings.ApplicationFont)
        End If
        If (btn.TabIndex = 1) Then
            If objDzoDraw.lstDrawOject.Count > 0 Then
                objDzoDraw.deselectAll()
                objDzoDraw.Draw()
                stmPdf.acrobat.Navigate("about:blank")
                stmPdf.Load(objDzoDraw.getBitmap())
            End If
        End If

    End Sub
    Public Sub setButtonSelectiobSelected()
        For Each ctrl In panelToolBarDesign.Controls
            If TypeOf ctrl Is CDButton Then
                If (ctrl.TabIndex = SELECTION) Then
                    ctrl.setSelected(True)
                Else
                    ctrl.setSelected(False)
                End If
            End If
        Next
    End Sub
    Private Sub HandleDynamicButtonClick(sender As Object, e As EventArgs)
        'On Error Resume Next
        Cursor = Cursors.Arrow
        For Each ctrl In panelToolBarDesign.Controls
            If TypeOf ctrl Is CDButton Then
                ctrl.setSelected(False)
            End If
        Next
        Dim btn As CDButton = DirectCast(sender, CDButton)
        For Each ctrl In panelToolBarDesign.Controls
            If TypeOf ctrl Is CDButton Then
                ctrl.setSelected(False)
                If (btn.TabIndex = ctrl.TabIndex) Then
                    If ctrl.TabIndex = ZOOM_M Then
                        objDzoDraw.ZooomM()
                        Exit Sub
                    ElseIf ctrl.TabIndex = ZOOM_P Then
                        objDzoDraw.ZooomP()
                        Exit Sub
                    End If
                End If
            End If
        Next
        If TypeOf btn Is CDButton Then
            objDzoDraw.FinalizeCurveDraw()
            btn.SetSelected(True)
            If btn.TabIndex <> COPY And btn.TabIndex <> DELETE Then
                objDzoDraw.deselectAll()
                ResetResize()
            End If
            nMode = btn.TabIndex
            Select Case btn.TabIndex
                Case CLEAR
                    btn.SetSelected(False)
                    objDzoDraw.Update()
                    Exit Sub
                Case DELETE
                    btn.SetSelected(False)
                    objDzoDraw.Draw()
                    Exit Sub
                Case COPY
                    objDzoDraw.CopySelectedObject()
                    Exit Sub
                Case PASTE
                    objDzoDraw.PasteCopiedObject()
                    btn.SetSelected(False)
                    Exit Sub
                Case IIMAGE
                    Dim fd As OpenFileDialog = New OpenFileDialog()
                    Dim strFileName As String
                    fd.Title = "Open File Dialog"
                    fd.InitialDirectory = "c:"
                    fd.Filter = "Jpeg files (*.jpg)|*.jpg|All files (*.*)|*.*"
                    fd.FilterIndex = 2
                    fd.RestoreDirectory = True
                    If fd.ShowDialog() = DialogResult.OK Then
                        strFileName = fd.FileName
                        imageBitmap = New Bitmap(strFileName)
                        objDzoDraw.Update()
                    Else
                        nMode = NONE
                    End If
                    btn.SetSelected(False)
                    Exit Sub
                Case GRID
                    bGrid = Not bGrid
                    If Not bGrid Then
                        btn.SetSelected(False)
                    End If
                    objDzoDraw.Draw()
                Case CURVE
                    objDzoDraw.lstCurveDrawOject.Clear()
                    objDzoDraw.bFinalizeDrawCurve = False
                Case EXIT_APP
                    Close()
                    End
            End Select
        End If

    End Sub

    Public Sub UpdateColors()
        On Error Resume Next
        If Not bActivated Or Me.WindowState = FormWindowState.Minimized Then Exit Sub
        Dim i As Integer
        If DrawPan.BackColor <> _designSettings.DesignBackColor Or
            DrawPan.ForeColor <> _designSettings.DesignForeColor Or
            tabsButton(2)._backColor <> _appSettings.MenuBackColor Then
            DrawPan.BackColor = _designSettings.DesignBackColor
            DrawPan.ForeColor = _designSettings.DesignForeColor
            For i = 0 To tabsButton.Length - 2
                tabsButton(i).updateTab(DrawPan.BackColor, _appSettings.MenuBackColor,
                                        _appSettings.ApplicationFont)
            Next
            tabsButton(1).updateTab(Color.FromArgb(224, 224, 224), _appSettings.MenuBackColor, _appSettings.ApplicationFont)
            tabsButton(2)._backColor = _appSettings.MenuBackColor
        End If
        If (ToolBarPan.BackColor <> _appSettings.ApplicationBackColor Or
            ToolBarPan.ForeColor <> _appSettings.ApplicationForeColor Or
            PropertiesPan.BackColor <> _appSettings.ApplicationBackColor Or
            PropertiesPan.ForeColor <> _appSettings.ApplicationForeColor) Then
            ToolBarPan.BackColor = _appSettings.ApplicationBackColor
            ToolBarPan.ForeColor = _appSettings.ApplicationForeColor
            PropertiesPan.BackColor = _appSettings.ApplicationBackColor
            PropertiesPan.ForeColor = _appSettings.ApplicationForeColor
        End If

        If Not arrButton(0) Is Nothing Then
            If arrButton(0).Font.Name <> _appSettings.ApplicationFont.Name Or
            arrButton(0).Font.Size <> _appSettings.ApplicationFont.Size Then
                ReOrder()
                draw()
            End If
            If arrButton(0).BackColor <> _appSettings.MenuBackColor Or
                arrButton(0).ForeColor <> _appSettings.MenuForeColor Then
                For Each ctrl In Me.ToolBarPan.Controls
                    If TypeOf ctrl Is CDButton Then
                        ctrl.updateIconsColor(_appSettings.MenuBackColor, _appSettings.MenuForeColor)
                    End If

                Next
            End If
        End If
        dmenu.UpdateColors(_appSettings.MenuBackColor, _appSettings.MenuForeColor)
        If nMode <> LABEL Then
            objDzoDraw.editText.Visible = False
        Else
            If (objDzoDraw.editText.Visible) Then
                If objDzoDraw.editText.ForeColor <> _designSettings.DesignForeColor Or
                    objDzoDraw.editText.BackColor <> _designSettings.DesignBackColor Or
                    BackColor <> objDzoDraw.editText.BackColor Then
                    objDzoDraw.editText.ForeColor = _designSettings.DesignForeColor
                    objDzoDraw.editText.BackColor = _designSettings.DesignBackColor
                    BackColor = objDzoDraw.editText.BackColor
                End If
                draw()
                Exit Sub
            End If
        End If
    End Sub

    Public Sub draw()
        If Not bActivated Then Exit Sub
        'Clear|Line| Line with arrow | Line double arrow |Pen | Rectangle| Cube | Eclipse|curves| bolt |Fill|Select|Copy|Paste|Cancel|Image|Text|Grid|Zoom - |Zoom +| Exit
        For Each ctrl In Me.ToolBar.Controls
            ctrl.SetSelected(False)
        Next
        Select Case nMode
            Case CLEAR
            Case LINE
            Case LINEARROW
            Case LINEARROWSE
            Case RECTANGLE
            Case ELLIPSE
            Case SELECTION
            Case DELETE
            Case LABEL
                arrButton(nMode).SetSelected(True)
        End Select
    End Sub





    Private Sub Design_MouseDown(sender As Object, e As MouseEventArgs) Handles DrawPan.MouseDown
        If objDzoDraw Is Nothing Then Exit Sub
        dmenu.MenuLeave()
        objDzoDraw.MouseDown(sender, e)
        If (Not objDzoDraw.editText.Visible) Then
            DrawPan.Select()
        End If
    End Sub

    Private Sub Design_MouseMove(sender As Object, e As MouseEventArgs) Handles DrawPan.MouseMove
        If objDzoDraw Is Nothing Then Exit Sub
        objDzoDraw.MouseMove(sender, e)
    End Sub

    Private Sub Design_MouseUp(sender As Object, e As MouseEventArgs) Handles DrawPan.MouseUp
        If objDzoDraw Is Nothing Then Exit Sub
        objDzoDraw.MouseUp(sender, e)

    End Sub
    Private Sub Design_KeyDown(sender As Object, e As KeyEventArgs) Handles DrawPan.KeyDown
        If objDzoDraw Is Nothing Then Exit Sub
        objDzoDraw.KeyDown(sender, e)
        objDzoDraw.Draw()
    End Sub

    Private Sub Design_KeyUp(sender As Object, e As KeyEventArgs) Handles DrawPan.KeyUp
        If objDzoDraw Is Nothing Then Exit Sub
        objDzoDraw.KeyUp(sender, e)
    End Sub


    Private Sub Properties_MouseEnter(sender As System.Object, e As System.EventArgs) Handles PropertiesPan.MouseEnter
        PropertiesPan.Cursor = Cursors.Arrow
    End Sub

    Private Sub PanelToolBar_MouseEnter(sender As System.Object, e As System.EventArgs) Handles ToolBarPan.MouseEnter
        ToolBarPan.Cursor = Cursors.Arrow
    End Sub


    Private Sub Design_Paint(sender As System.Object, e As System.Windows.Forms.PaintEventArgs) Handles DrawPan.Paint
        If objDzoDraw Is Nothing Then Exit Sub
        objDzoDraw.Draw()
    End Sub


    Private Sub Design_Leave(sender As System.Object, e As System.EventArgs) Handles DrawPan.Leave
        If objDzoDraw Is Nothing Then Exit Sub
        If objDzoDraw.editText.Visible Then
            objDzoDraw.editText.Visible = False
            nMode = NONE
        End If
    End Sub


    Private Sub Design_Scroll(sender As System.Object, e As System.Windows.Forms.ScrollEventArgs) Handles DrawPan.Scroll
        If objDzoDraw Is Nothing Then Exit Sub
        objDzoDraw.Draw()

    End Sub

    Private Sub Design_MouseDoubleClick(sender As System.Object, e As System.Windows.Forms.MouseEventArgs) Handles DrawPan.MouseDoubleClick
        If objDzoDraw Is Nothing Then Exit Sub
        objDzoDraw.deselectAll()
        objDzoDraw.Draw()
    End Sub

    Private Sub Design_PreviewKeyDown(sender As System.Object, e As System.Windows.Forms.PreviewKeyDownEventArgs) Handles DrawPan.PreviewKeyDown

    End Sub

    Private Sub Properties_Paint(sender As System.Object, e As System.Windows.Forms.PaintEventArgs) Handles PropertiesPan.Paint

    End Sub

    Private Sub Properties_MouseHover(sender As System.Object, e As System.EventArgs) Handles PropertiesPan.MouseHover

    End Sub

    Private Sub GlControl1_Load(sender As System.Object, e As System.EventArgs)

    End Sub

    Private Sub PanelMenu_Paint(sender As System.Object, e As System.Windows.Forms.PaintEventArgs) Handles MenuPan.Paint

    End Sub

    Private Sub PanelToolBar_Paint(sender As System.Object, e As System.Windows.Forms.PaintEventArgs) Handles ToolBarPan.Paint

    End Sub

    Private Sub ToolBar_Paint(sender As System.Object, e As System.Windows.Forms.PaintEventArgs) Handles ToolBar.Paint

    End Sub

    Private Sub Principal_Resize(sender As System.Object, e As System.EventArgs) Handles MyBase.Resize
        If logo Is Nothing Then Exit Sub
        logo.Invalidate()
    End Sub

    Private Sub Design_MouseLeave(sender As System.Object, e As System.EventArgs) Handles DrawPan.MouseLeave
    End Sub

    Private Sub Design_MouseEnter(sender As System.Object, e As System.EventArgs) Handles DrawPan.MouseEnter

    End Sub

    Private Sub Principal_Activated(sender As System.Object, e As System.EventArgs) Handles MyBase.Activated
        _designSettings.setPrincipal(Me)
    End Sub

  
    Private Sub Timer1_Tick(sender As System.Object, e As System.EventArgs)

    End Sub
End Class






