﻿''''''''''''''''''''''''''''''''''
' Author - Nasri 2022 dzosoft.com
'''''''''''''''''''''''''''''''''''

Imports System.ComponentModel
Imports System.Xml
Imports System.Xml.Serialization
Imports System.IO

''---------------------Design

'<Serializable()>
Public Class DesignSettings : Implements ISettings
    Protected _size As System.Drawing.Size
    Const HORIZONTAL = "Horizonal"
    Private _DesignFont As Font
    Private _DesignBackColor As Color = New Color()
    Private _DesignForeColor As Color = New Color()
    Private _DesignDirectionText As String = HORIZONTAL
    Private _DesignFillColor As Color = New Color()
    Private _DesignFillColor2 As Color = New Color()
    Private _PenStyle As String = Principal.SOLID_STYLE
    Private _PenSize As String = "1"
    Private _Text As String
    Private _bringToFront As Boolean = False
    Private colorCombination As String
    Private _DesignBitmap As String
    Private princ As Principal



    Public Sub setPrincipal(ByRef _princ As Principal)
        princ = _princ
    End Sub

    Private Sub draw()
        If princ IsNot Nothing Then
            princ.UpdateColors()
        End If
    End Sub

    Public Property WindowSize() As System.Drawing.Size
        Get
            Return _size
        End Get
        Set(ByVal value As System.Drawing.Size)
            _size = value
        End Set
    End Property
    <Category("Design Font"),
       Browsable(True),
       [ReadOnly](False),
       Bindable(False),
       DefaultValue(""),
       DesignOnly(False),
       Description("Enter the font")>
    Public Property DesignFont() As System.Drawing.Font
        Get
            Return _DesignFont
        End Get
        Set(ByVal Value As System.Drawing.Font)
            _DesignFont = Value
            If princ IsNot Nothing Then
                princ._designSettings._DesignFont = Value
                draw()
            End If
        End Set
    End Property

    <Category("Design Color"),
       Browsable(True),
       [ReadOnly](False),
       Bindable(False),
       DefaultValue(""),
       DesignOnly(False),
       Description("Enter the color")>
    Public Property DesignBackColor() As Color
        Get
            Return _DesignBackColor
        End Get
        Set(ByVal Value As Color)
            _DesignBackColor = Value
            If princ IsNot Nothing Then
                princ._designSettings._DesignBackColor = Value
                draw()
            End If
        End Set
    End Property
    Public Property DesignForeColor() As Color
        Get
            Return _DesignForeColor
        End Get
        Set(ByVal Value As Color)
            _DesignForeColor = Value
            If princ IsNot Nothing Then
                princ._designSettings._DesignForeColor = Value
                draw()
            End If
        End Set
    End Property
    Public Property DesignFillColor() As Color
        Get
            Return _DesignFillColor
        End Get
        Set(ByVal Value As Color)
            _DesignFillColor = Value
            If princ IsNot Nothing Then
                princ._designSettings._DesignFillColor = Value
                draw()
            End If
        End Set
    End Property

    Public Property DesignFillColor2() As Color
        Get
            Return _DesignFillColor2
        End Get
        Set(ByVal Value As Color)
            _DesignFillColor2 = Value
            If princ IsNot Nothing Then
                princ._designSettings._DesignFillColor2 = Value
                draw()
            End If
        End Set
    End Property
    <TypeConverter(GetType(DirectionTextValues)),
       Category("Text direction"),
       Browsable(True),
       [ReadOnly](False),
       Bindable(False),
       DefaultValue("Horizonal"),
       DesignOnly(False),
       Description("Enter the direction of the text")>
    Public Property DesignDirectionText() As String
        Get
            Return _DesignDirectionText
        End Get
        Set(ByVal Value As String)
            _DesignDirectionText = Value
            If princ IsNot Nothing Then
                princ._designSettings._DesignDirectionText = Value
                draw()
            End If
        End Set
    End Property

    <Editor(GetType(BrushPanel), GetType(System.Drawing.Design.UITypeEditor)),
   DefaultValue(""),
   Description("BrushBitmap"),
   Category("Disegno Bitmap")>
    Public Property DesignBitmap() As String
        Get
            Return _DesignBitmap
        End Get
        Set(ByVal Value As String)
            _DesignBitmap = Value
            If princ IsNot Nothing Then
                princ._designSettings._DesignBitmap = Value
                draw()
            End If
        End Set
    End Property

    Public Sub Load() Implements ISettings.Load
        Dim reader As TextReader
        Dim fileNotFound As Boolean
        Dim fontName As String = ""
        Try
            reader = New StreamReader(Principal.xmlDesignSetting)
        Catch ex As FileNotFoundException
            ' Take the defaults
            fileNotFound = True
        End Try

        If fileNotFound Then
            WindowSize = New System.Drawing.Size(308, 774)
            _DesignBackColor = Color.White
            _DesignForeColor = Color.Black
            _DesignFont = New Font("Arial", 8)
            _DesignFillColor = Color.White
            _DesignFillColor2 = Color.White
            _DesignDirectionText = HORIZONTAL
        Else
            Dim xr As XmlReader = XmlReader.Create(Principal.xmlDesignSetting)
            Do While xr.Read()
                Dim read As Boolean = False

                If (xr.NodeType = XmlNodeType.Element) Then

                    If xr.NodeType = XmlNodeType.Element AndAlso xr.Name = "Size" Then
                        Dim s() As String
                        Dim s1 As Integer
                        Dim s2 As Integer
                        Dim svalue = xr.ReadElementString()
                        svalue = svalue.Replace("{", "")
                        svalue = svalue.Replace("}", "")
                        s = svalue.Split(",")
                        s1 = CInt(s(0).Substring(s(0).IndexOf("=") + 1))
                        s2 = CInt(s(1).Substring(s(1).IndexOf("=") + 1))
                        WindowSize = New Size(s1, s2)
                        read = True
                    End If
                    If xr.NodeType = XmlNodeType.Element AndAlso xr.Name = "FontName" Then
                        fontName = xr.ReadElementString()
                        read = True
                    End If
                    If xr.NodeType = XmlNodeType.Element AndAlso xr.Name = "FontSize" Then
                        If (fontName <> "") Then
                            DesignFont = New Font(fontName, CInt(xr.ReadElementString()))
                        End If
                        read = True
                    End If

                    If xr.NodeType = XmlNodeType.Element AndAlso xr.Name = "BackColor" Then
                        Dim svalue = xr.ReadElementString()
                        DesignBackColor = Color.FromArgb(CInt(svalue))
                        read = True
                    End If
                    If xr.NodeType = XmlNodeType.Element AndAlso xr.Name = "ForeColor" Then
                        Dim svalue = xr.ReadElementString()
                        DesignForeColor = Color.FromArgb(CInt(svalue))
                        read = True
                    End If
                    If xr.NodeType = XmlNodeType.Element AndAlso xr.Name = "DirectionText" Then
                        DesignDirectionText = xr.ReadElementString()
                        read = True
                    End If
                    If xr.NodeType = XmlNodeType.Element AndAlso xr.Name = "FillColor" Then
                        Dim svalue = xr.ReadElementString()
                        DesignFillColor = Color.FromArgb(CInt(svalue))
                        read = True
                    End If
                    If xr.NodeType = XmlNodeType.Element AndAlso xr.Name = "FillColor2" Then
                        Dim svalue = xr.ReadElementString()
                        DesignFillColor2 = Color.FromArgb(CInt(svalue))
                        read = True
                    End If
                    If xr.NodeType = XmlNodeType.Element AndAlso xr.Name = "BrushBitmap" Then
                        DesignBitmap = xr.ReadElementString()
                        read = True
                    End If
                    If (Not read) Then
                        xr.Read()
                    End If

                Else

                    xr.Read()
                End If
            Loop

            xr.Close()
            reader.Close()
        End If
    End Sub
    Public Sub SaveSetting(_xmlDesignSetting As String) Implements ISettings.SaveSetting
        Dim xws As XmlWriterSettings = New XmlWriterSettings()
        xws.Indent = True
        xws.NewLineOnAttributes = True
        Dim xw As XmlWriter = XmlWriter.Create(_xmlDesignSetting, xws)
        xw.WriteStartDocument()
        xw.WriteStartElement("Settings")
        xw.WriteElementString("Size", WindowSize.ToString)
        If Not DesignFont Is Nothing Then
            xw.WriteElementString("FontName", DesignFont.Name)
            xw.WriteElementString("FontSize", DesignFont.Size)
        End If
        xw.WriteElementString("BackColor", DesignBackColor.ToArgb().ToString())
        xw.WriteElementString("ForeColor", DesignForeColor.ToArgb().ToString())
        xw.WriteElementString("DirectionText", DesignDirectionText)
        xw.WriteElementString("FillColor", DesignFillColor.ToArgb().ToString())
        xw.WriteElementString("FillColor2", DesignFillColor2.ToArgb().ToString())
        xw.WriteElementString("BrushBitmap", DesignBitmap)
        xw.WriteEndElement()
        xw.WriteEndDocument()
        xw.Flush()
        xw.Close()
    End Sub
    Public Sub SaveSetting(ByRef obj As ptObject) Implements ISettings.SaveSetting
    End Sub
    Public Sub Load(obj As ptObject) Implements ISettings.Load
    End Sub

    Public Function getCountProperties() Implements ISettings.getCountProperties
        Return 5
    End Function
End Class