﻿''''''''''''''''''''''''''''''''''
' Author - Nasri 2022 dzosoft.com
'''''''''''''''''''''''''''''''''''

Imports System.ComponentModel
Imports System.Xml
Imports System.Xml.Serialization
Imports System.IO
Imports System.Drawing.Design


'<Serializable()>
Public Class ObjSetting : Implements ISettings
    Private _Font As Font
    Private _FillColor As Color = New Color()
    Private _FillColor2 As Color = New Color()
    Private _ForeColor As Color = New Color()
    Private _PenStyle As String = Principal.SOLID_STYLE
    Private _PenSize As String = "1"
    Private _Text As String
    Private _TextDirection As String = "Horizontal"
    Private _bringToFront As Boolean = False
    Private objPt As ptObject
    Private color As String
    Private _fileName As String
    Private _bitmap As String
    Private _dcube As Integer


    <Editor(GetType(clsFileDialog), GetType(System.Drawing.Design.UITypeEditor)),
    DefaultValue(""),
    Description("FileName"),
    Category("Draw")>
    Public Property FileName() As String
        Get
            Return _fileName
        End Get
        Set(ByVal value As String)
            _fileName = value
        End Set
    End Property

    <Editor(GetType(BrushPanel), GetType(System.Drawing.Design.UITypeEditor)),
   DefaultValue(""),
   Description("BrushBitmap"),
   Category("Draw")>
    Public Property BrushBitmap() As String
        Get
            Return _bitmap
        End Get
        Set(ByVal value As String)
            _bitmap = value
        End Set
    End Property

    <Editor(GetType(ColorsPanel), GetType(System.Drawing.Design.UITypeEditor)),
   DefaultValue(""),
   Description("Colors"),
   Category("Draw")>
    Public Property Colors() As String
        Get
            Return color
        End Get
        Set(ByVal value As String)
            color = value
        End Set
    End Property
    <Category("Draw"),
       Browsable(True),
       [ReadOnly](False),
       Bindable(False),
       DefaultValue(""),
       DesignOnly(False),
       Description("Text ")>
    Public Property Text() As String
        Get
            Return _Text
        End Get
        Set(ByVal value As String)
            _Text = value
        End Set
    End Property
    <TypeConverter(GetType(DirectionTextValues)),
       Category("Draw"),
       Browsable(True),
       [ReadOnly](False),
       Bindable(False),
       DefaultValue("Horizontal"),
       DesignOnly(False),
       Description("Text direction ")>
    Public Property TextDirection() As String
        Get
            Return _TextDirection
        End Get
        Set(ByVal value As String)
            _TextDirection = value
        End Set
    End Property
    <Category("Draw"),
       Browsable(True),
       [ReadOnly](False),
       Bindable(False),
       DefaultValue(""),
       DesignOnly(False),
       Description("Font")>
    Public Property Font() As System.Drawing.Font
        Get
            Return _Font
        End Get
        Set(ByVal Value As System.Drawing.Font)
            _Font = Value
        End Set
    End Property

    <Category("Draw"),
       Browsable(True),
       [ReadOnly](False),
       Bindable(False),
       DefaultValue(""),
       DesignOnly(False),
       Description("ForeColor")>
    Public Property ForeColor() As Color
        Get
            Return _ForeColor
        End Get
        Set(ByVal value As Color)
            _ForeColor = value
        End Set
    End Property
    <Category("Draw"),
       Browsable(True),
       [ReadOnly](False),
       Bindable(False),
       DefaultValue(""),
       DesignOnly(False),
       Description("FillColor")>
    Public Property FillColor() As Color
        Get
            Return _FillColor
        End Get
        Set(ByVal value As Color)
            _FillColor = value
        End Set
    End Property
    <Category("Draw"),
       Browsable(True),
       [ReadOnly](False),
       Bindable(False),
       DefaultValue(""),
       DesignOnly(False),
       Description("FillColor2")>
    Public Property FillColor2() As Color
        Get
            Return _FillColor2
        End Get
        Set(ByVal value As Color)
            _FillColor2 = value
        End Set
    End Property

    <TypeConverter(GetType(PenStyleList)),
      Category("Draw"),
      Browsable(True),
      [ReadOnly](False),
      Bindable(False),
      DefaultValue("_______________"),
      DesignOnly(False),
      Description("PenStyle")>
    Public Property PenStyle() As String
        Get
            Return _PenStyle
        End Get
        Set(ByVal value As String)
            _PenStyle = value
        End Set
    End Property

    <TypeConverter(GetType(PenSizeList)),
     Category("Draw"),
     Browsable(True),
     [ReadOnly](False),
     Bindable(False),
     DefaultValue("1"),
     DesignOnly(False),
     Description("PenSize")>
    Public Property PenSize() As String
        Get
            Return _PenSize
        End Get
        Set(ByVal value As String)
            _PenSize = value
        End Set
    End Property
    <Category("Draw"),
     Browsable(True),
     [ReadOnly](False),
     Bindable(False),
     DefaultValue("1"),
     DesignOnly(False),
     Description("PenSize")>
    Public Property DCube() As Integer
        Get
            Return _dcube
        End Get
        Set(ByVal value As Integer)
            _dcube = value
        End Set
    End Property
    <Category("Draw"),
   Browsable(True),
   [ReadOnly](False),
   Bindable(False),
   DefaultValue(False),
   DesignOnly(False),
   Description("BringToFront")>
    Public Property BringToFront() As Boolean
        Get
            Return _bringToFront
        End Get
        Set(ByVal value As Boolean)
            _bringToFront = value
        End Set
    End Property
    Public Sub SaveSetting(ByRef obj As ptObject) Implements ISettings.SaveSetting
        obj.font = _Font
        obj.FillColor = _FillColor
        obj.FillColor2 = _FillColor2
        obj.ForeColor = _ForeColor
        obj.penStyle = _PenStyle
        obj.penSize = _PenSize
        obj.text = _Text
        obj.directionText = _TextDirection
        obj.bringToFront = _bringToFront
        obj.brushBitmap = _bitmap
        obj.dCube = _dcube
    End Sub
    Public Sub Load(obj As ptObject) Implements ISettings.Load
        _Font = obj.font
        _FillColor = obj.FillColor
        _FillColor2 = obj.FillColor2
        _ForeColor = obj.ForeColor
        _PenStyle = obj.penStyle
        _PenSize = obj.penSize
        _Text = obj.text
        _TextDirection = obj.directionText
        _bringToFront = obj.bringToFront
        _bitmap = obj.brushBitmap
        _dcube = obj.dCube
    End Sub

    Public Sub Load() Implements ISettings.Load
    End Sub
    Public Sub SaveSetting(_xmlAppSetting As String) Implements ISettings.SaveSetting
    End Sub

    Public Function getCountProperties() Implements ISettings.getCountProperties
        Return 7
    End Function

End Class