﻿''''''''''''''''''''''''''''''''''
' Author - Nasri 2022 dzosoft.com
'''''''''''''''''''''''''''''''''''


Imports System.ComponentModel
Imports System.Xml
Imports System.Xml.Serialization
Imports System.IO

Public Class Settings

    Private _appSettings As AppSettings
    Private _xmlAppSetting As String
    Private _designSettings As DesignSettings
    Private _xmlDesignSetting As String

    Public Sub New(appSettings As AppSettings,
                   xmlAppSetting As String,
                   designSettings As DesignSettings,
                   xmlDesignSetting As String)
        _appSettings = appSettings
        _xmlAppSetting = xmlAppSetting
        _designSettings = designSettings
        _xmlDesignSetting = xmlDesignSetting

    End Sub

    Public Sub SalvaAppSetting()
        Dim xws As XmlWriterSettings = New XmlWriterSettings()
        xws.Indent = True
        xws.NewLineOnAttributes = True
        Dim xw As XmlWriter = XmlWriter.Create(_xmlAppSetting, xws)
        xw.WriteStartDocument()
        xw.WriteStartElement("Settings")
        xw.WriteElementString("Title", _appSettings.Title)
        xw.WriteElementString("Show", _appSettings.Show)
        xw.WriteElementString("Size", _appSettings.WindowSize.ToString)
        If Not _appSettings.ApplicationFont Is Nothing Then
            xw.WriteElementString("FontName", _appSettings.ApplicationFont.Name)
            xw.WriteElementString("FontSize", _appSettings.ApplicationFont.Size)
        End If
        xw.WriteElementString("BackColor", _appSettings.ApplicationBackColor.ToArgb().ToString())
        xw.WriteElementString("ForeColor", _appSettings.ApplicationForeColor.ToArgb().ToString())
        xw.WriteElementString("MenuBackColor", _appSettings.MenuBackColor.ToArgb().ToString())
        xw.WriteElementString("MenuForeColor", _appSettings.MenuForeColor.ToArgb().ToString())
        xw.WriteEndElement()
        xw.WriteEndDocument()
        xw.Flush()
        xw.Close()
    End Sub
    Public Sub SalvaDesignSetting()
        Dim xws As XmlWriterSettings = New XmlWriterSettings()
        xws.Indent = True
        xws.NewLineOnAttributes = True
        Dim xw As XmlWriter = XmlWriter.Create(_xmlDesignSetting, xws)
        xw.WriteStartDocument()
        xw.WriteStartElement("Settings")
        xw.WriteElementString("Size", _designSettings.WindowSize.ToString)
        If Not _designSettings.DesignFont Is Nothing Then
            xw.WriteElementString("FontName", _designSettings.DesignFont.Name)
            xw.WriteElementString("FontSize", _designSettings.DesignFont.Size)
        End If
        xw.WriteElementString("BackColor", _designSettings.DesignBackColor.ToArgb().ToString())
        xw.WriteElementString("ForeColor", _designSettings.DesignForeColor.ToArgb().ToString())
        xw.WriteElementString("DirectionText", _designSettings.DesignDirectionText)
        xw.WriteEndElement()
        xw.WriteEndDocument()
        xw.Flush()
        xw.Close()
    End Sub




End Class
